<?php

//---------------------------------------------------------------------------
// jrfconvert.php
// by mouser@donationcoder.com, mar 1. 2010
//
// this script oversees a converter/importer process
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// app info
$global_ApplicatioName = 'jrfconvert (File Converter/Importer)';
$global_ApplicationVersionString = 'v1.02.01 (March 5th, 2010)';
$global_ApplicationAuthor = 'mouser@donationcoder.com';
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// announce
echo $global_ApplicatioName . ' - ' . $global_ApplicationVersionString . ' - ' . $global_ApplicationAuthor . "\n\n";
//---------------------------------------------------------------------------











//---------------------------------------------------------------------------
// options will be set in this array
$global_Options=array();
$global_default_Options=array();
// current directory
$global_ThisScriptDir =  dirname(__FILE__);
// argc and argv
$global_argc=$argc;
$global_argv=$argv;
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// default options
$global_default_Options['classid']='jjmw';
//
$global_default_Options['basedir']=$global_ThisScriptDir;
$global_default_Options['inputdir']='data';
$global_default_Options['usegetpostoptions']=0;
$global_default_Options['debug']=0;
$global_default_Options['recurse']=0;
$global_default_Options['filepatterns']='*.*';
$global_default_Options['excludepatterns']='';
$global_default_Options['stat_files_failed']=0;
$global_default_Options['stat_files_success']=0;
$global_default_Options['stat_files_skipped']=0;
$global_default_Options['stat_files_replaced']=0;
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// grab commandline and form options and override defaults with them
// CALL #1 of 2 -- we actually call this TWICE, once here before instantiating converter object to get options it needs
//  and then once more AFTER the object is initiated to get overrides again
// As an example of where this is useful -- the classid commandline arg may instantiate an object
//  which wants to set its OWN DEFAULT COMMANDLINE args, which can be overridden
$global_Options = $global_default_Options;
ParseAddCommandlineGlobalOptions();
//---------------------------------------------------------------------------












//---------------------------------------------------------------------------
// instantiate the importer class that will do all the work
// this may also RESET some global option defaults
require_once($global_ThisScriptDir . '/jrfconvert_converterclass.php');
//
$converterobj = jrfc_ConverterClassT::InstantiateDerivedClass($global_Options['classid'],$global_Options);
if ($converterobj==NULL)
	{
	echo 'FATAL ERROR: The derived converter class (' . $global_Options['classid'] . ') was not found; exiting.' . "\n";
	exit();
	}
echo 'Using Converter Class: ' . $global_Options['classid'] . "\n";
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// now get any default options from object and overwrite our defaults
// note that we reset to global default options in order to throw out any grabbed in first commandline/form parse
$objdefaultoptions = $converterobj->GetDefaultOptions();
$global_Options = array_merge($global_default_Options,$objdefaultoptions);
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// re-parse any commandline options that will override defaults set by class
// CALL #2 of 2
ParseAddCommandlineGlobalOptions();
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// and now tell the object about the true options
$converterobj->AddOptions($global_Options);
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
// init it
if (!$converterobj->Init_Prepare())
	exit();
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// truly truly evil fucking stupid assanine bullshit moronic php global problem
// some things like media wiki REQUIRE files to be included in global scope
//  but guess what, this is impossible to do from a function or class
//  so we have to use this technique to do it in global scope
foreach ($global_Options['globalrequires'] as $fname)
	{
	if (isset($global_Options['debug']) && $global_Options['debug']!==0)
		echo 'DEBUG Globally including: ' . $fname . "\n";
	require_once($fname);
	}
// 'E:\WebsiteHttp\mediawiki\maintenance\commandLine.inc');
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// init it
if (!$converterobj->Init_Final())
	exit();
//---------------------------------------------------------------------------














//---------------------------------------------------------------------------
// run it and report any errors
$converterobj->Run();
//---------------------------------------------------------------------------






//---------------------------------------------------------------------------
// report stats
$converterobj->ReportStats();
//---------------------------------------------------------------------------































//---------------------------------------------------------------------------
// helper functions - specific to this app
//

function ParseAddCommandlineGlobalOptions()
{
	// parse any commandline or form options and optionally display them
	global $global_Options;

	$comargs = jj_GetCommandLineArgs();
	$global_Options=array_merge($global_Options,$comargs);
	//
	// merge in get/post args?
	if (isset($global_Options['usegetpostoptions']) && $global_Options['usegetpostoptions']!==0)
		{
		if (!empty($_GET))
			$global_Options=array_merge($global_Options,$_GET);
		if (!empty($_POST))
			$global_Options=array_merge($global_Options,$_POST);
		}
	//
	// debug
	if (isset($global_Options['debug']) && $global_Options['debug']!==0)
		{
		echo 'DEBUG OF options: ';
		print_r($global_Options);
		}


	// any cleanup on options to make sure they are safe
	$global_Options['classid']=ereg_replace("[^A-Za-z0-9_]", "", $global_Options['classid']);
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// helper functions - generic
//

function jj_GetCommandLineArgs()
{
	// return commandline args
	global $global_argc,$global_argv;
	$retarray=array();
	//
	if ($global_argc<=1)
		return array();
	//
	//$realargc = count($argv);

	for ($i=1;$i<$global_argc;++$i)
		{
		$astr = $global_argv[$i];
		$astrsplit=explode('=',$astr,2);
		$varname = trim($astrsplit[0]);
		// remove -- leading chars
		while (strlen($varname)>0 && $varname[0]=='-')
			$varname=substr($varname,1,strlen($varname)-1);
		//
		if (count($astrsplit)<=1)
			$retarray[$varname]='';
		else
			$retarray[$varname]=trim($astrsplit[1]);
		}
	//
	return $retarray;
}
//---------------------------------------------------------------------------
