<?php

// jrfconvert_converterclass
// by mouser@donationcoder.com, mar 1. 2010
//
// this file defines the jrfc_ConverterClassT class which does most of the work important pages and images, etc.

require_once('jr_mwihelpers.php');


class jrfc_ConverterClassT
{
	// for keeping track of errors, warnings
	protected	$errorwarninglog = array();
	protected $options = array();

	// we will use this to help us track and fixup the conversions of filenames to titles in more complicated ways
	protected $filenametitlemap = array();






//---------------------------------------------------------------------------
function __construct()
{
	// main constructor
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
function GetDefaultOptions()
{
	$defaultoptions = array();

	$defaultoptions['deletetempfiles']=0;
	$defaultoptions['justclean']=0;
	$defaultoptions['test']=0;

	return $defaultoptions;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
function Init_Prepare()
{
	// check options report any errors and return FALSE if should stop

	// one thing we might do is ask global scope to include files for us here
	//global $global_Options;
	//$global_Options['globalrequires'][]=$fname_to_include_globally;

	return TRUE;
}


function Init_Final()
{
	// check options report any errors and return FALSE if should stop
	return TRUE;
}
//---------------------------------------------------------------------------













































//---------------------------------------------------------------------------
function SetOptions($in_options)
{
	// set options, erase previous
	$this->options=$in_options;
}

function AddOptions($in_options)
{
	// add some options overiding existing
	$this->options=array_merge($this->options,$in_options);
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
function GeneratePageName(&$filedata)
{
	// given $filedata (which contains contents and filename,etc.)
	// generate a mediawiki page name; pages with same name will be overwritten or archived
	//
	// @return true on success, false on error (skips processing file)
	// @set pagename as $filedata['mwpagename']
	return FALSE;
}


function ModifyPageData(&$filedata)
{
	// given $filedata (which contains contents and filename,etc.)
	// do any generic modification to page data (remove unwanted elements, etc.)
	//
	// @return true on success, false on error (skips processing file)
	// @modify $filedata['contents']
	return FALSE;
}
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
function ClearLog()
{
	// clear error warning log
	$this->errorwarninglog = array();
}

function GetLog($flag_clearit)
{
	// return log and optionally clear it
	$retv = $this->errorwarninglog;
	if ($flag_clearit)
		$this->ClearLog();
	return $retv;
}

function AddToLog($newentry)
{
	$this->errorwarninglog[]=$newentry;
}

function AddInfoToLog($str)
{
	$this->AddToLog(array('type'=>'info','text'=>$str));
}

function AddErrorToLog($str)
{
	$this->AddToLog(array('type'=>'error','text'=>$str));
}

function DisplayLog($flag_clearit)
{
	$logarray = $this->GetLog($flag_clearit);
	foreach ($logarray as $logentry)
		{
		echo ' ' . $logentry['type'] . ': ' . $logentry['text'] . "\n";
		if (count($logentry)>2)
			{
			foreach ($logentry as $logpropname => $logpropval)
				{
				echo '    ' . $logpropname . ': ' . $logpropval . "\n";
				}
			}
		}
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
public static function InstantiateDerivedClass($derivedclassid,$preview_global_Options)
{
	// instantiate the importer class that will do all the work
	$importerclassfile = 'jrfconvert_converterclass_' . $derivedclassid . '.php';
	$importerclassname = 'jrfc_ConverterClassT_' . $derivedclassid;
	//
	// current directory
	$this_script_dir =  dirname(__FILE__);
	$fname = $this_script_dir . '/' . $importerclassfile;
	if (!file_exists($fname))
		return NULL;
	//
	require_once($fname);
	//
	// instantiate
	$derivedobj = new $importerclassname();

	// do we need to handle any preview_global_Options specially?
	// if not, we will be called again and told to add the $global_Options, so we don't need to deal with them now

	//
	return $derivedobj;
	}
//---------------------------------------------------------------------------









//---------------------------------------------------------------------------
function Run()
{
	// announce start
	echo 'Running converter script..' . "\n";

	// run the import and display any errors

	// early stuff
	$this->BeforeRun();

	// clean temp files
	$this->RunCleaning();

	if ($this->options['justclean']===0)
		{
		// pre-process?
		$this->RunProcess('PreProcessFile');

		// run
		$this->RunProcess('ProcessFileWrapper');
		}

	if ($this->options['deletetempfiles']!==0)
		{
		// clean after
		$this->RunCleaning();
		}

	// late stuff
	$this->AfterRun();

	// display log (errors, etc.)
	$this->DisplayLog(TRUE);

	if (true || $this->isdebugmode())
		{
		// show the file map
		$this->DisplayFinalDebugInfo();
		}

	// announce end
	echo 'Done with converter script.' . "\n";
}
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
function BeforeRun()
{
	// do any stuff before main run
}

function AfterRun()
{
	// do any stuff after main run
}
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
function RunProcess($fileinvocationfunction)
{
	// process all files in the specified directory (and recursively if appropriate)
	$inputdir = $this->globalfydir($this->options['inputdir'],$this->options['basedir']);
	$this->ProcessDirectory($inputdir,'',$this->options['recurse'],$fileinvocationfunction);
}
//---------------------------------------------------------------------------






//---------------------------------------------------------------------------
function ProcessDirectory($dir,$reldirname,$flag_recurse,$fileinvocationfunction)
{
	// process files in a directory
	//

	// error if doesnt exist
	if (!file_exists($dir))
		{
		$this->AddToLog(array('type'=>'error','text'=>'Directory specified for processing (' . $dir . ') does not exist.'));
		return FALSE;
		}

	// keep track of current directory in options
	$this->options['curdir']=$dir;
	$this->options['curdir_relative']=$reldirname;

	// process all files (and subdirs if recursice)
	$diriteraor = new DirectoryIterator($dir);
	foreach ($diriteraor as $file)
		{
		// working vars
		$fname = $file->getFilename();
		$fname_fullpath = $file->getPathname();
		if ($reldirname == '')
			$fname_relpath = $fname;
		else
			$fname_relpath = $reldirname . '/' . $fname;
		// handle self dir
		if ($file->isDot())
			continue;
		// handle directory
		if ($file->isDir())
			{
			if ($flag_recurse!==0)
				{
				if ($this->ShouldProcessSubDir($fname_fullpath,$fname_relpath,$fname))
					{
					// recursively call subdirectory
					$this->ProcessDirectory($fname_fullpath, $fname_relpath, $flag_recurse,$fileinvocationfunction);
					}
				}
			continue;
			}
		// handle file
		if ($this->ShouldProcessFile($fname_fullpath,$fname_relpath,$fname))
			{
			$fileo=array('fname'=>$fname,'fname_fullpath'=>$fname_fullpath,'fname_relpath'=>$fname_relpath,'extension'=>$this->jrfc_calcfileextension($fname_fullpath));
			// process it
			$this->$fileinvocationfunction($fileo);
			// report progress
			$this->DisplayLog(true);
			}
		}

	// success
	return TRUE;
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
function ShouldProcessSubDir($fname_fullpath,$fname_relpath,$fname)
{
	// should we recurse into this subdir? (assuming recursive option is on)
	// what we really want to check here is dir name against exclusions
	$exclusions = $this->options['excludepatterns'];
	if ($this->Test_StrPatternMatches($fname,$exclusions))
		return FALSE;
	return TRUE;
}


function ShouldProcessFile($fname_fullpath,$fname_relpath,$fname)
{
	// should we process this file?
	// what we really want to check here is dir name against exclusions and inclusions
	$inclusions = $this->options['filepatterns'];
	$exclusions = $this->options['excludepatterns'];
	if ($this->Test_StrPatternMatches($fname,$exclusions))
		return FALSE;
	if (empty($inclusions) || $this->Test_StrPatternMatches($fname,$inclusions))
		return TRUE;
	return FALSE;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
function Test_StrPatternMatches($str,$strpatterns)
{
	// $strpatterns is a comma separated list of simple wildcard patterns (or regexs)
	// for example '*.html,*.htm,*.png,*.gif,*.jpg';
	// our strategy is:
	// split into array
	// for each pattern, convert it to a regex, unless a special prefix tells us that is is already regex

	if (empty($strpatterns))
		return FALSE;

	if (!is_array($strpatterns))
		{
		// first convert to array
		$strpatterns = explode(',',$strpatterns);
		foreach ($strpatterns as &$pat)
			{
			if (strlen($pat)<1)
				continue;
			if ($pat[0]=='$')
				{
				// already a regex, just remove $ and done
				$pat=substr($pat,1,strlen($pat)-1);
				}
			else
				{
				// not a regex
				// lowercase it
				$pat = strtolower($pat);
				// replace . with \. and * with .* and ? with .?
				$pat = str_replace('.','\.',$pat);
				$pat = str_replace('*','.*',$pat);
				$pat = str_replace('?','.?',$pat);
				// add anchors
				$pat = '^' . $pat . '$';
				}
			}
		}

	// now return TRUE if ANY pattern matches
	foreach ($strpatterns as $pat)
		{
		// ok now we regex match $str against $pat (case insensitive)
		$retv = eregi($pat,$str);
		if ($retv)
			return TRUE;
		}

	// not matched
	return FALSE;
}
//---------------------------------------------------------------------------






//---------------------------------------------------------------------------
function ReportStats()
{
	// report generic stats
	echo "\n\n";
	echo 'Final stats:' . "\n";
	foreach ($this->options as $key => $val)
		{
		if (strpos($key,'stat_')===0)
			{
			echo substr($key,5) . " \t = " . $val . "\n";
			}
		}
}
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
function LoadFileContentsForFileo(&$fileo)
{
	$fname = $fileo['fname_fullpath'];
	$fileo['contents']=file_get_contents($fname);
}
//---------------------------------------------------------------------------











//---------------------------------------------------------------------------
function ProcessFileWrapper($fileo)
{
	// called before we pass along to ProcessFile
	if (!$this->jrfc_veryifyfile($fileo))
		return FALSE;
	//
	if ($this->options['test']!==0)
		{
		// dont actually process
		$this->AddToLog(array('type'=>'info','text'=>'*SIMULATING* Processing of file "' . $fileo['fname_fullpath'] . '".'));
		return;
		}

	// announce
	$this->AddToLog(array('type'=>'info','text'=>'Processing file "' . $fileo['fname_fullpath'] . '".'));

	// call derived process
	$this->ProcessFile($fileo);
}


function ProcessFile($fileo)
{
	//
	$this->AddToLog(array('type'=>'info','text'=>'Processing file "' . $fileo['fname_fullpath'] . '".'));
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function PreProcessFile($fileo)
{
	// this is optional
	// in phase 1 the PreProcess file function gets called for every file, before any converting is done
	// in phase 2 we convert
	// this lets us make a map of all filenames for advanced processing
	//
	//$this->AddToLog(array('type'=>'info','text'=>'PreProcessing file "' . $fileo['fname_fullpath'] . '".'));

	// store nice lookup table of file objects
	$this->filenametitlemap[$fileo['fname_relpath']]=$fileo;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function get_cachedfileo($fileo)
{
	$fname_relpath=$fileo['fname_relpath'];
	if (isset($this->filenametitlemap[$fileo['fname_relpath']]))
		return $this->filenametitlemap[$fileo['fname_relpath']];
	// not found
	return NULL;
}
//---------------------------------------------------------------------------





























//---------------------------------------------------------------------------
function RunCleaning()
{
	// now set our inclusions and exclusions for cleanup
	$cleanpatterns = $this->GetTempFilePatterns();
	if ($cleanpatterns!="")
		{
		// save these since we are going to temporarily replace them (kludgish i know)
		$inclusions = $this->options['filepatterns'];
		$exclusions = $this->options['excludepatterns'];

		// use cleaning patterns
		$this->options['filepatterns'] = $cleanpatterns;
		$this->options['excludepatterns'] = '';

		// run cleanup
		$this->RunProcess('CleanProcessFile');

		// restore
		$this->options['filepatterns'] = $inclusions;
		$this->options['excludepatterns'] = $exclusions;
		}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function GetTempFilePatterns()
{
	// return temp file patterns to delete or "" for none,
	// should be comma separated like so: '*.wiki,*.wiki2,*.preprocessed'
	$cleanpatterns = '';
	return $cleanpatterns;
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
function CleanProcessFile($fileo)
{
	// called on files to delete
	$fname = $fileo['fname_fullpath'];
	$fname_relpath=$fileo['fname_relpath'];

	if ($this->options['test']!==0)
		{
		// dont actually process
		$this->AddToLog(array('type'=>'info','text'=>'*SIMULATING* Cleaning deletion of file "' . $fname . '".'));
		return;
		}

	$this->AddToLog(array('type'=>'info','text'=>'Cleaning by deleting file "' . $fname_relpath . '".'));
	// ATTN: unfinished
	unlink($fname);
}
//---------------------------------------------------------------------------





















//---------------------------------------------------------------------------
// helpers follow
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function jrfc_calcfileextension($fname_fullpath)
{
	// return lowercase versioon of filename, with no .
	$lastdotpos = strrpos($fname_fullpath,'.');
	if ($lastdotpos===FALSE)
		return '';
	$ext = substr($fname_fullpath,$lastdotpos+1);
	return strtolower($ext);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
function jrfc_veryifyfile($fileo)
{
	$retv=file_exists($fileo['fname_fullpath']);
	if (!$retv)
		$this->AddToLog(array('type'=>'error','text'=>'The following file was not found: "' . $fileo['fname_fullpath'] . '".'));
	return $retv;;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function jrfc_iswindowsos()
{
	// return TRUE if we are running on windows OS
	//
	global $_ENV,$_SERVER;

	$OS='';
	if (isset($_ENV['OS']))
		$OS = $_ENV['OS'];
	else if (isset($_SERVER['OS']))
		$OS = $_SERVER['OS'];

	//echo 'OS = ' . $OS;

	if (strpos(strtolower($OS),'windows')!==FALSE)
		return TRUE;
	return FALSE;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function isdebugmode()
{
	if (isset($this->options['debug']) && $this->options['debug']!==0)
		return TRUE;
	return FALSE;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function arraypropenabled($ary,$varname)
{
	if (isset($ary[$varname]) && $ary[$varname]!==FALSE && $ary[$varname]!==0)
		return TRUE;
	return FALSE;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function addvalwithnewline($val)
{
	if (empty($val))
		return '';
	return $val . "\n";
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function globalfydir($dir,$basedir)
{
	// add base directory to local dir IFF needed

	// fixup ../ parent paths
	$len=strlen($dir);
	if ($len>=3 && $dir[0]=='.' && $dir[1]=='.')
		{
		// ATTN: todo
		// we don't handle this yet -- for now just return it untouched
		return $dir;
		}

	$len=strlen($basedir);
	//
	if ($len>0 && ($basedir[$len-1]=='/' || $basedir[$len-1]=='\\'))
		$basedir=substr($basedir,1,$len-1);
	//
	if (strlen($dir)>=2 && $dir[0]!='/' && $dir[1]!=':')
		{
		if ($dir[0]=='.' && $dir[1]=='/')
			{
			$dir=$basedir . substr($dir,2);
			}
		else
			{
			$dir=$basedir . '/' . $dir;
			}
		}
	//
	// cleanup end
	$len=strlen($dir);
	if ($len>0 && ($dir[$len-1]=='/' || $dir[$len-1]=='\\'))
		$dir=substr($dir,1,$len-1);
	//
	return $dir;
	}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
function DisplayFinalDebugInfo()
{
	echo '------------------------------' . "\n";
	$farray = array($this->filenametitlemap);
	// echo jr_DumpArray('Filename Tile Map',$farray );
	//echo '------------------------------ PRINTR' . "\n";
	//print_r($farray);
}
//---------------------------------------------------------------------------



}
